% Build the incidence matrix 
% ATTENTION: brackets are necessary
% ATTENTION: order of commands in crucial
C_Inc = (kron(ones(1,length(mpc.bus(:,1))),mpc.branch(:,18)) == ones(length(mpc.branch(:,1)),1) * [1:length(mpc.bus(:,1))]) + ...  % Positive indices 
        (-1).*(kron(ones(1,length(mpc.bus(:,1))),mpc.branch(:,19)) == ones(length(mpc.branch(:,1)),1) * [1:length(mpc.bus(:,1))]); % Negative indices

% Build the reduced incidence matrix (w/o slack node)
C_IncWoS = C_Inc; 
C_IncWoS(:,mpc.bus(:,8)==3) = [];
% Build the reduced node (bus) matrix (w/o slack node)
mpc.busWoS = mpc.bus;
mpc.busWoS(mpc.busWoS(:,8)==3,:) = [];

B_flow = diag(mpc.branch(:,12).^(-1)) * C_IncWoS;
B_bus = C_IncWoS.' * B_flow;

[U, S, V]= svd(B_bus);
s = diag(S); 
k = sum(s> 1e-9); % simple thresholding based decision
B_bus_inv = (U(:, 1: k)* diag(1./ s(1: k))* V(:, 1: k)')';

PTDF = B_flow * B_bus_inv;
 
% Results for the power flows of the original grid
P_flow_lines = PTDF * mpc.busWoS(:,12);

% calculate power flows
P_flow = zeros(num_lines,num_scenarios);
node_IND = find(mpc.bus(:,8)==2);
for i = 1:num_scenarios
    P_flow(:,i) = PTDF * node_injections(node_IND,i);
end
