 disp('build reduced grid equivalent');
 c = clock;
 disp(datestr(datenum(c(1),c(2),c(3),c(4),c(5),c(6))));


% Define orientations AND connections of branches from the equivalent grid
% First approach (maybe inefficient) try all combinations
% => for i=1:number of Zones: (for all zones in Z ~= Z(i)) ...
% => for all x in Z(i): if one y from Z(j) exists & (x,y) element of mcp.branch -> (Z(i),Z(j)) is element of mcp.branchR 
% NOTE: A more efficient approach would be to restrict possible zone combinations to neighbour zones (could be done via introducing area/zone combinations in mcp.bus)
% NOTE: The most efficient way would be to predefine the connection matrix
mpc.branchR = [];
mpc.clusterBranchSumID = [];

k = 0; %running variable that increases with the development of mpc.branchR 
for i=1:num_clusters, %from cluster
    for j=1:num_clusters, %to cluster
        if(j > i)
        clusterID_j = find(mpc.bus(:,7) == j);
        clusterID_i = find(mpc.bus(:,7) == i);
        [pairs_i, pairs_j] = meshgrid(mpc.bus(clusterID_i,11),mpc.bus(clusterID_j,11));
        pairs_ij = [pairs_i(:) pairs_j(:)];
        pairs_ji = [pairs_j(:) pairs_i(:)];
        %other solution -> more complicated because intra-zonal flows has to be removed
        %pairs_ij = combnk([mpc.bus(clusterID_i,1); mpc.bus(clusterID_j,1)],2); %all possible line-pair combinations (no repetition) containing a node of cluster i and cluster j
        %pairs_ij(~ismember(pairs_ij(:,1),mpc.bus(clusterID_i,1)),:) = []; %remove all combinations that are intra-zonal flows (= do not start in cluster 1)
        pairs_all = mpc.branch(:,18:19); %all existing connections of the original grid
        [pairs_ijR_1, pairs_allID_ij, pairs_ijID] = intersect( pairs_all, pairs_ij, 'rows');
        
 % PROBLEM THAT NEG. ORIENTED PAIR GET NOT INTO THE LIST
        [pairs_jiR_2, pairs_allID_ji, pairs_jiID] = intersect( pairs_all, pairs_ji, 'rows'); %lines in different orientation than in between clusters should also be counted
        pairs_ijR = [pairs_ijR_1; pairs_jiR_2];
        pairs_allID = [pairs_allID_ij; pairs_allID_ji];
        
            if( ~isempty(pairs_ijR)), %Do mcp.branch contain a line between Z(i) and Z(j)?
                k=k+1; 
                BranchSum = ( ismember(mpc.branch(:,18), mpc.bus(clusterID_i,11)).' & ismember(1:length(mpc.branch(:,18)), pairs_allID) ).* 1 + ...
                            ( ismember(mpc.branch(:,18), mpc.bus(clusterID_j,11)).' & ismember(1:length(mpc.branch(:,18)), pairs_allID) ).*(-1);
                mpc.clusterBranchSumID(k,:) = BranchSum; %all indices of
                if i<j, %branch orientation of reduced grid is chosen in a way that orientation of flows go from clusters with smallest ID to the ones with higher IDs 
                mpc.branchR = [mpc.branchR;[0 i   j	0	0	1	0	0	0	0	0	0	0]]; %initial values of reduced branch matrix without defining the orientation
                else mpc.branchR = [mpc.branchR;[0  j	i	0	0	1	0	0	0	0	0	0   0]]; 
                end
            end
        end     
    end
end

mpc.branchR(:,1) = unique(1:length(mpc.branchR(:,1)));
num_linesR = length(mpc.branchR(:,1));

%%
% reinstate combined parallel inter-zonal lines to multiple power lines

u = 0;
delete_reduced_lines = zeros(num_linesR,1);

for i = 1:num_linesR % for all reduced lines
    from_nodes_IND = find(mpc.bus(:,7)==mpc.branchR(i,2)); %find nodes belonging to from_cluster
    to_nodes_IND = find(mpc.bus(:,7)==mpc.branchR(i,3)); %find nodes belonging to to_cluster
    if mpc.bus(to_nodes_IND(1),6) ~= mpc.bus(from_nodes_IND(1),6) % if inter-zonal
    
    number_from_nodes = length(from_nodes_IND); % count nodes belonging to from_cluster
    number_to_nodes = length(to_nodes_IND); % count nodes belonging to to_cluster
    for j = 1:number_from_nodes
    
        line_IND1 = find(mpc.branch(:,18)==from_nodes_IND(j));  % find all lines connected to the from-nodes
        number_line_IND1 = length(line_IND1);

        if number_line_IND1 > 0

            for k = 1:number_line_IND1
                if sum(ismember(mpc.branch(line_IND1(k),19),to_nodes_IND)) > 0 % if a line containing the from_node connects a to_node
                   u = u + 1;  % add line from line list to reduced line list
                   mpc.branchR(num_linesR+u,:) = zeros(1,13); 
                   mpc.branchR(num_linesR+u,2:5) = mpc.branchR(i,2:5);  
                   mpc.branchR(num_linesR+u,6:8) = mpc.branch(line_IND1(k),11:13);
                   mpc.clusterBranchSumID(num_linesR+u,:) = zeros(1,num_lines); 
                   mpc.clusterBranchSumID(num_linesR+u,line_IND1(k)) = 1; 
                end    
            end
        end

        line_IND2 = find(mpc.branch(:,19)==from_nodes_IND(j));
        number_line_IND2 = length(line_IND2);

        if number_line_IND2 > 0

            for k = 1:number_line_IND2  
                if sum(ismember(mpc.branch(line_IND2(k),18),to_nodes_IND)) > 0 % if a line containing the from_node connects a to_node
                   u = u + 1;  % add line from line list to reduced line list
                   mpc.branchR(num_linesR+u,:) = zeros(1,13); 
                   mpc.branchR(num_linesR+u,2:5) = mpc.branchR(i,2:5);  
                   mpc.branchR(num_linesR+u,6:8) = mpc.branch(line_IND2(k),11:13);
                   mpc.clusterBranchSumID(num_linesR+u,:) = zeros(1,num_lines); 
                   mpc.clusterBranchSumID(num_linesR+u,line_IND2(k)) = -1; 
                end    
            end 
        end
    end
    delete_reduced_lines(i) = 1;
    end
end

mpc.branchR(find(delete_reduced_lines==1),:) = [];
mpc.clusterBranchSumID(find(delete_reduced_lines==1),:) = [];
num_linesR = length(mpc.branchR);

%% create reduced bus matrix (clusters), based on the combined properties of the old bus matrix
mpc.busR = zeros(num_clusters,12);
 %first colum of the matrix is numbered

for i =1:num_clusters
    node_IND = find(mpc.bus(:,7) == i); % find cluster numbers in node matrix
    mpc.busR(i,1) = mpc.bus(node_IND(1),7); % cluster number
    mpc.busR(i,2) = mpc.bus(node_IND(1),6); % country
    mpc.busR(i,9) = mean(mpc.bus(node_IND,9)); %X coordinate
    mpc.busR(i,10) = mean(mpc.bus(node_IND,10)); %Y coordinate
    mpc.busR(i,12) = sum(mpc.bus(node_IND,12)); %injection
end

mpc.busR(:,8) = 2; %slack node
for i = 1:num_nodes
    if mpc.bus(i,8) == 3
mpc.busR(mpc.bus(i,7),8) = 3; %slack node
    end
end

% fill in reduced branch matrix

for i = 1:num_lines
mpc.branch(i,23) = mpc.bus(mpc.branch(i,18),7);
mpc.branch(i,24) = mpc.bus(mpc.branch(i,19),7);
end