
% create matrix describing which cluster belongs to which zone

 disp('calculate error metric');
 c = clock;
 disp(datestr(datenum(c(1),c(2),c(3),c(4),c(5),c(6))));

mpc.clusterZoneID=zeros(num_clusters,1);


mpc.clusterZoneID(mpc.bus(:,7),1) = mpc.bus(:,6);

number_scenarios = 959;
%%
%preallocation of memory
Error_abs = zeros(number_scenarios,length(PTDF_R(:,1)));
Error_rel = zeros(number_scenarios,length(PTDF_R(:,1)));

num_linesR = length(mpc.branchR(:,1));

node_IND = find(mpc.bus(:,8)==2);
for i=1:number_scenarios
P_flow_clusters_actual = mpc.clusterBranchSumID * PTDF * node_injections(node_IND,i);
P_flow_clusters_reduced = PTDF_R * gamma_R * node_injections(node_IND,i);

Error_abs(i,:) = abs(P_flow_clusters_reduced-P_flow_clusters_actual);  % absolute error      
end
%%
% measure error relative to total NTC values
NTC_flows = (abs(mpc.clusterBranchSumID)*abs(mpc.branch(:,13)))'; % the total capacity between two nodes

for i=1:num_linesR-1
Error_rel(:,i)=Error_abs(:,i) /NTC_flows(1,i); %  % relative error compared to total capacity between two nodes
end

Error_rel_av = mean(Error_rel)'; % average error of each flow 
%%
% create matrix with per zone the list of flows in it

zone_counter=zeros(number_zones,1);
flowZoneID = [];
for i=1:num_linesR
    if mpc.clusterZoneID(mpc.branchR(i,2))~= mpc.clusterZoneID(mpc.branchR(i,3))
    zoneID = mpc.clusterZoneID(mpc.branchR(i,2));
    zone_counter(zoneID,1) = zone_counter(zoneID,1) +1;
    flowZoneID(zone_counter(zoneID,1),zoneID)=i;
    zoneID = mpc.clusterZoneID(mpc.branchR(i,3));
    zone_counter(zoneID,1) = zone_counter(zoneID,1) +1;
    flowZoneID(zone_counter(zoneID,1),zoneID)=i;
    end
end
%%
%create matrix with per zone the list of flowerrors in it
for i=1:number_zones
    for j=1:length(flowZoneID(:,1))
        if flowZoneID(j,i) ~= 0
        Error_per_Zone(j,i) = Error_rel_av(flowZoneID(j,i),1);
        end
    end
end

% take average from errors in flows
average_Error_per_Zone = zeros(1,number_zones);
columnlength = zeros(1,number_zones);

for i=1:number_zones
    if size(find(Error_per_Zone(:,i)~=0),1)~=0
    columnlength(1,i)=max(find(Error_per_Zone(:,i)~=0));
    end
    if columnlength(1,i)~=0 
        average_Error_per_Zone(1,i) = sum(Error_per_Zone(:,i))./columnlength(1,i);
    end
end