
 disp('calculate properties reduced grid');
 c = clock;
 disp(datestr(datenum(c(1),c(2),c(3),c(4),c(5),c(6))));
 
% Build the incidence matrix of the reduced grid
% ATTENTION: brackets are necessary
% ATTENTION: order of commands is crucial
C_IncR = (kron(ones(1,length(mpc.busR(:,1))),mpc.branchR(:,2)) == ones(length(mpc.branchR(:,1)),1) * [1:length(mpc.busR(:,1))]) + ...  % Positive indices 
         (-1).*(kron(ones(1,length(mpc.busR(:,1))),mpc.branchR(:,3)) == ones(length(mpc.branchR(:,1)),1) * [1:length(mpc.busR(:,1))]); % Negative indices

% Build the reduced incidence matrix (w/o slack node)
C_IncRWoS = C_IncR; 
C_IncRWoS(:,mpc.busR(:,8)==3) = [];
% Build the reduced node (bus) matrix (w/o slack node)
mpc.busRWoS = mpc.busR;
mpc.busRWoS(mpc.busRWoS(:,8)==3,:) = [];

LR = length(mpc.branchR(:,1));
NR = length(mpc.busRWoS(:,1));
%%
%Arbitrary matrix 
Lambda = zeros(LR*NR,LR);

for i=1:NR,
Lambda(1+(i-1)*LR:LR+(i-1)*LR,:) = (PTDF_R * C_IncRWoS.' - eye(LR)) * diag(C_IncRWoS(:,i));
end
%%
%Calculate average angle difference between zones
%NOTE: In a further step the NODE angles should be averaged in each zone and from that the difference should be taken phi* = phi1* - phi2*
% - This calculation should be the result of a DC power flow calculation with the original grid
% - But what about the varying averages of the angles over time? Reduce quadratic error of time sequence?
theta_diff = P_flow_lines .* mpc.branch(:,12);
mpc.clusterBranchSumID_test = mpc.clusterBranchSumID;

theta_diff_cluster = abs(mpc.clusterBranchSumID * theta_diff./sum(abs(mpc.clusterBranchSumID)')');

%Calculation of the reactances
%NOTE: There is no unique solution to derive from PDTF data reactances -> they should be physically correct, therefore angle limitations from the original grid are used as benchmark
%%
Lambda_ext = [eye(length(theta_diff_cluster)); Lambda]; %Additional side constraints that angle difference of reduced grid should be in the range of the intra-zonal average angle differences of the orignial gird

b_ext = [abs(P_flow_clusters) ./ theta_diff_cluster; zeros(length(Lambda),1)]; %ride-hand side of the reactances equation
%xR_inv = (Lambda_ext.' * Lambda_ext)^(-1) * Lambda_ext.' * b_ext; %the solution of the equation Lambda_ext * (1/x_R) = b_ext
xR_inv = Lambda_ext \ b_ext; %straight solution of the equation without former reshaping of the equation

mpc.branchR(:,5) = abs(1./ xR_inv); %the reactances of the reduced grid are written into the reduced grid branch matrix

for i = 1:num_linesR
    line_IND11 = find(mpc.branch(:,23) == mpc.branchR(i,2));
    line_IND12 = find(mpc.branch(:,24) == mpc.branchR(i,3));
    line_IND1 = intersect(line_IND11,line_IND12);
    
    line_IND21 = find(mpc.branch(:,24) == mpc.branchR(i,2));
    line_IND22 = find(mpc.branch(:,23) == mpc.branchR(i,3));
    line_IND2 = intersect(line_IND21,line_IND22);
    line_IND = [line_IND1; line_IND2];

     mpc.branchR(i,4) = 1/sum(1./mpc.branch(line_IND,11));
     mpc.branchR(i,6) = sum(mpc.branch(line_IND,13));
end