number_zones = max(mpc.bus(:,6));
num_nodes_in_zone = zeros(number_zones,1);
num_clusters_in_zone = zeros(number_zones,1);
zone_reactance_cutoff = zeros(number_zones,1);


clusterintensity = [0;0.175;0;0.175;0.175;0.05;0.175;0.05;0.1;0.125;0.125;0.125;0.125;0.125;0.075;0.125;0.225;0.225;0.225;0.225;0.075;0.2;0.225;0.5;0.5;0.15;0.025];
number_nodes = length(mpc.bus(:,1));
num_lines = length(mpc.branch(:,1));
mpc.bus(:,7) = 0;

%calculate clustering condition value = resistance*dgen/capacity
for i=1:num_lines
    mpc.branch(i,20) = abs(mpc.branch(i,12));
end
% +1 for the zero avoidance
  
%normalize condition index from 0 to 1
max_treshold = max(mpc.branch(:,20));
mpc.branch(:,20) = mpc.branch(:,20)/max_treshold;

g=0;

% assign cluster ID's based on clustering condition, clustering process gets repeated while enheightening the condition treshold
% until desired zone size is reached

for j=1:number_zones
    
    num_nodes_in_zone(j,1) = length(mpc.bus(mpc.bus(:,6) ==j)); 
    num_clusters_in_zone(j,1) = num_nodes_in_zone(j,1); % number of clusters in zone is initally equal to the number of nodes
    treshold=0.000000000001; % starting value of the treshold for each country
    
    zone_nodes_IND = find(mpc.bus(:,6) ==j); %
    zone_nodes = mpc.bus(zone_nodes_IND,:); %selection of only nodes of the current zone
   
    zone_branches_IND = find(mpc.branch(:,21)==j & mpc.branch(:,22)==j);
    
    zone_branches = mpc.branch(zone_branches_IND,:); % selection of only branches IN the current zone
    
    
    num_branches_zone = length(zone_branches(:,1));
    
    
    
    if length(zone_nodes(:,1)) > 0
    t = 0; % counting variable to prevent infinite looping
   
    while num_clusters_in_zone(j,1)>=(clusterintensity*num_nodes_in_zone(j,1)) & t<=300 %condition determining whether the cluster process for this zone is ready or not 
        u = 0; 
        for i=1:num_branches_zone  
            
            if (zone_branches(i,20)<treshold) % line resistance condition for line aggregation
                u = u +1;
                %create clustersID's  
                    from_IND = find(mpc.bus(:,11) == zone_branches(i,18)); %find the from_node of a branch in the zone nodes
                    
                    to_IND = find(mpc.bus(:,11) == zone_branches(i,19));  %find the to_node of a branch in the zone nodes
                    
                    if  mpc.bus(from_IND,7) ~= 0 && mpc.bus(to_IND,7) ~= 0 % if both nodes from a branch already have a cluster number, the to_node gets the number of the from_node
                   
                    replace_cluster = mpc.bus(to_IND,7);
                    for l=1:number_nodes
                        if mpc.bus(l,7) == replace_cluster;
                             
                            mpc.bus(l,7) = mpc.bus(from_IND,7);
                        end
                    end
                    
                elseif mpc.bus(from_IND,7) ~= 0 % if only the from_node already has a cluster number, the to_node gets the number of the from_node
                    mpc.bus(to_IND,7)= mpc.bus(from_IND,7);
                elseif mpc.bus(to_IND,7) ~= 0 % if only the to_node already has a cluster number, the from_node gets the number of the to_node
                    mpc.bus(from_IND,7) = mpc.bus(to_IND,7);
                    else % if none of the nodes of a branch has a cluster number, the cluster counter is going up 1, and both from_node and to_node get this cluster number assigned
                        
                    g=g+1;
                    mpc.bus(from_IND,7) =g;
                    mpc.bus(to_IND,7) =g;
                    end            
            end   
        end  
        
        %number all unnumbered nodes in the zone
        for b=1:number_nodes
            if mpc.bus(b,6) == j
            if mpc.bus(b,7) == 0
              g = g+1;
              mpc.bus(b,7) = g;         
            end
                
            end
              %}  
         end
         
        %create again a matrix of the busses in the zone
        zone_nodes = mpc.bus(zone_nodes_IND,:); %filter out all the branches outside the current zone
        %count the clusters in the zone    
        num_clusters_in_zone(j,1) = length(unique(zone_nodes(:,7)));

        %double the treshold
        treshold = treshold*1.1;   
        t= t +1; 
        % if the number of clusters is not low enough yet, the while loop
        % is repeated with a lower treshold value
    end
    zone_reactances = sort(zone_branches(:,12));
    zone_reactance_cutoff(j) = zone_reactances(u);
    end
    
end

%renumber from 1 to num_clusters,
replace_cluster = zeros(number_nodes,1);
num_clusters = length(unique(mpc.bus(:,7)));
for i=1:num_clusters 
rep_clus = find(mpc.bus(:,7) == max(mpc.bus(:,7)));
replace_cluster(rep_clus,1) = i;
mpc.bus(rep_clus,7)=0;
end

mpc.bus(:,7) = replace_cluster(:,1);

% create matrix describing which which cluster belongs to which node
mpc.clusterNodeSumID = zeros(num_clusters,number_nodes); %matrix containing the indices of node injections in mpc.bus of zone i of the reduced grid
for i=1:num_clusters, 
    mpc.clusterNodeSumID(i,:) = ismember(mpc.bus(:,7),i)'; 
end;
