 disp('calculate reduced PTDF');
 c = clock;
 disp(datestr(datenum(c(1),c(2),c(3),c(4),c(5),c(6))));
 
node_IND = find(mpc.bus(:,8)==2);
cluster_IND = find(mpc.busR(:,8) == 2 );
P_flow_clusters = mpc.clusterBranchSumID * P_flow_lines; %%matrix containing the sum of power flows resulting from the original grid in between the zones according to zone definition in mcp.branchR
% NOTE:
% - The dimension of the matrices is important in order to split the matrix in 2 products, whereas one into a quadratic size that can be inverted.

% ----- Calculate the PDTF of the reduced grid ----- %%
gamma_R = mpc.clusterNodeSumID(cluster_IND,node_IND); %maps the indices of power injections from the original grid nodes to clusters
% The PTDF_R are being calculated by setting the intra-clusteral clusters equal to the branch flows of the reduced grid

% take out zeros in matrix, so no singular matrix will occur
matrix = gamma_R * mpc.bus(node_IND,12);

PTDF_R = mpc.clusterBranchSumID * PTDF * diag(mpc.bus(node_IND,12)) * gamma_R.' * (diag(matrix))^(-1); %Power flows are collected just for the reduced network (without slack)
