clear all
clc

number_nodes = 100;
number_hours = 8760;
%%
% create dummy variables
nominal_generation = rand(number_hours,number_nodes);
nominal_demand = rand(number_hours,number_nodes);
co_nodes = rand(number_nodes,2)*90;
%%
weighted_co_generation = zeros(number_hours,2);
weighted_co_demand = zeros(number_hours,2);


weighted_co_generation(:,1) = nominal_generation * co_nodes(:,1) ./sum(nominal_generation')';
weighted_co_generation(:,2) = nominal_generation * co_nodes(:,2) ./sum(nominal_generation')';

weighted_co_demand(:,1) = nominal_demand * co_nodes(:,1) ./sum(nominal_demand')';
weighted_co_demand(:,2) = nominal_demand * co_nodes(:,2) ./sum(nominal_demand')';

D_gen_dem = zeros(number_hours,1);

for i = 1:number_hours
D_gen_dem(i) = vdist(weighted_co_generation(i,2),weighted_co_generation(i,1),weighted_co_demand(i,2),weighted_co_demand(i,1));
end

sum_D_gen_dem = zeros(number_hours-168,1);

for i = 1:number_hours-168
sum_D_gen_dem(i) = sum(D_gen_dem(i:i+168));
end

weekstart = find(sum_D_gen_dem == max(sum_D_gen_dem));